// Copyright (C) 2010 - H. Nahrstaedt
//


data = linspace (0, 10, 1001);
computed = nan_histc (data, 0:10);
expected = [repmat(100, 1, 10), 1];

assert_checkalmostequal ( computed , expected , %eps );


data = repmat (linspace (0, 10, 1001), [2, 1, 3]);
computed = nan_histc (data, 0:10, 2);
expected = repmat ([repmat(100, 1, 10), 1], [2, 1, 3]);

assert_checkalmostequal ( computed(:) , expected(:) , %eps );
