// Copyright (C) 2010 - H. Nahrstaedt
//

A=[1,2,10;7,7.1,7.01];

computed = nan_median(A);
expected = median(A,'r');

assert_checkalmostequal ( computed , expected , %eps );

computed = nan_median(A,2);
expected = median(A,'c');

assert_checkalmostequal ( computed , expected , %eps );

computed = nan_median(A(:));
expected = median(A);

assert_checkalmostequal ( computed , expected , %eps );


A=[1 1 %nan];
computed = nan_median(A);
expected = 1;

assert_checkalmostequal ( computed , expected , %eps );

A=[1 1 %nan];
computed = nan_median(A');
expected = 1;

assert_checkalmostequal ( computed , expected , %eps );

A=matrix([-9 3 -8 6 74 39 12 -6 -89 23 65 34],[2,3,2]);
computed = nan_median(A,3);
expected = median(A,3);

assert_checkalmostequal ( computed , expected , %eps );

computed = nan_median(A);
expected = median(A,'m');

assert_checkalmostequal ( computed(:) , expected(:) , %eps );



computed = nan_median([1,%nan,3,%inf,-%inf]);
expected = 2;

assert_checkalmostequal ( computed , expected , %eps );

computed = nan_median([1,%nan,3,%inf,4,-%inf]);
expected = 3;

assert_checkalmostequal ( computed , expected , %eps );

